//-------------------------------------
// Timing functions:
//  timer object records time at app launch
//  timer.time() returns time in seconds (float) relative to base
//  timer.reset() resets an elapsed time counter
//  timer.elapse() returns elapsed time (in seconds) since last reset
//
timer = {base: new Date().getTime() / 1000.0, start: 0.0}

timer.time = function() {
    return new Date().getTime() / 1000.0 - this.base;
};

timer.reset = function() {
    this.start = timer.time();
};

timer.elapsed = function() {
    return timer.time() - this.start;
};


// EOF
