 //-------------------------------------
// Debugging support:
//  zam.log() joins arguments with spaces and writes to log queue
//  zam._worker()
//
zam = {
    _count: 0,
    worker_ready: false,
    queue: [],
    outdir: 'file:///SDCard/log-' + blackberry.identity.PIN + '/'
    };


zam.log = function() {
    var args = [timer.time().toFixed(3) + ':'];
    for (var i = 0; i < arguments.length; i++)  // var x in arguments)
        args.push(arguments[i]);
    var text = args.join(' ');
    this.queue.push(text);

    if (!this.worker_ready) {
        setTimeout(zam._worker, 50);
        this.worker_ready = true;
    }
};

zam._worker = function() {
    //~ zam.queue.length = 0;
    //~ return;

    if (!blackberry.io.dir.exists(zam.outdir)) {
        blackberry.io.dir.createNewDir(zam.outdir);
    }

    zam._count++;
    var path = zam.outdir + 'out' + zam._count + '.msg';

    text = zam.queue.join('\n');
    zam.queue.length = 0;

    // takes about 50-100ms to write typical blocks of text
    var blob = blackberry.utils.stringToBlob(text + '\x7f', 'ascii');
    blackberry.io.file.saveFile(path, blob);

    zam.worker_ready = false;
};


// EOF
