import os
import sys
import glob
import re
import time
import datetime as dt
import threading

pat = re.compile(r'out(\d+).msg')

stale = []
def remover():
    while 1:
        if stale:
            nuke_after_delay = stale[:]
            del stale[:len(nuke_after_delay)]
            time.sleep(0.5)
            for name in nuke_after_delay:
                os.remove(os.path.join(srcdir, name))
                seenfiles.remove(name)
                #~ print 'removed', name

        else:
            time.sleep(0.5)

remover = threading.Thread(target=remover)
remover.setDaemon(True)
remover.start()

try:
    PIN = sys.argv[1]
except IndexError:
    sys.exit('must specify device PIN as argument');
srcdir = 'log-' + PIN

count = 1
seenfiles = set() # all those we've seen
DELAY = 0.10
while 1:
    # find all current files
    try:
        allfiles = set(os.listdir(srcdir))
    except OSError: # directory doesn't exist.. just loop
        time.sleep(DELAY)
        continue

    # identify which are new since last scan
    newfiles = allfiles - seenfiles

    # no new ones, so just re-scan
    if not newfiles:
        time.sleep(DELAY)
        continue

    #~ print 'new files', newfiles
    while newfiles:
        next = 'out%s.msg' % count
        if next in newfiles:
            path = os.path.join(srcdir, next)
            while 1:
                try:
                    msg = open(path).read()
                except OSError:
                    pass
                else:
                    if msg.endswith('\x7f'):
                        msg = msg[:-1]
                        break
                time.sleep(0.01)

            seenfiles.add(next)
            stale.append(next)
            newfiles.remove(next)
            print msg
            count += 1
            continue

        # reset: app has restarted
        elif 'out1.msg' in newfiles:
            print '=' * 40
            print 'restart at', dt.datetime.now()
            count = 1
            continue

        else:
            print 'whoa, out of sync', count
